package org.jboss.as.quickstarts.jms;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Logger;
 
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;
 
import org.hornetq.api.core.DiscoveryGroupConfiguration;
import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.api.jms.HornetQJMSClient;
import org.hornetq.api.jms.JMSFactoryType;
import org.hornetq.core.remoting.impl.netty.NettyConnectorFactory;
import org.hornetq.core.remoting.impl.netty.TransportConstants;
import org.hornetq.jms.client.HornetQQueue;
 
public class MyJMSClient {
    private static final Logger LOGGER = Logger.getLogger(MyJMSClient.class.getName());
 
    public static void main(String[] args) throws Exception {
        Connection connection = null;
        final String groupAddress = "231.7.7.7";

        final int groupPort = 9876;
        try {
            Queue queue = new HornetQQueue("testQueue");
            Map<String, Object> connectionParams = new HashMap<String, Object>();
            connectionParams.put(TransportConstants.CLUSTER_CONNECTION, "231.7.7.7:9876");     
            //connectionParams.put(TransportConstants.PORT_PROP_NAME, 5445);
            TransportConfiguration transportConfiguration = new TransportConfiguration(NettyConnectorFactory.class.getName(), connectionParams);
          //  ConnectionFactory cf = (ConnectionFactory) HornetQJMSClient.createConnectionFactoryWithoutHA(JMSFactoryType.QUEUE_CF, transportConfiguration);     
            ConnectionFactory cf = (ConnectionFactory) HornetQJMSClient.createConnectionFactoryWithHA(new DiscoveryGroupConfiguration(groupAddress, groupPort), JMSFactoryType.QUEUE_CF);     
            //JBoss requires passwords to have at least one numeric and non-alpha character
            connection = cf.createConnection("admin","erasmo");
            Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
           
            	MessageProducer producer = session.createProducer(queue);
            	connection.start();
            
           for (int i = 0; i < 1000; i++) {  
                     	
                     TextMessage message = session.createTextMessage("Howdy!");
                     producer.send(message);
           	}
            
            
            MessageConsumer consumer = session.createConsumer(queue);
            //Message can also be consumed from here:
    //     for (int i = 0; i < 1000; i++) {  
      //        	message = (TextMessage) consumer.receive(3000);
	   //         LOGGER.info(message.getText());
        //    }
            LOGGER.info("Esco dal For");
        } catch (Exception e) {
        	LOGGER.info("Esco dal For catch");
            LOGGER.severe(e.getMessage());
        } finally {
            if(connection != null){
                connection.close();
            }
        }
    }
}